// Array拡張
Array.prototype.allMethodCall = function(fun) {
	for (var i = 0; i < this.length; ++i) {
		fun(this[i]);
	}
}

// tmlibのほとんどのクラスにセット…
tm.app.Object2D.prototype.property_set = function(set_obj){
    for (var key in set_obj){
        this[key] = set_obj[key];
    }			
};

// 背景の為のスプライト
tm.define("tm.app.SpriteBack", {
			superClass : "tm.app.Sprite",
			init : function(f_name) {
				this.superInit(f_name);
				this.f_name = f_name;
			},
			imageSet : function(f_name) {
				this.image = tm.asset.AssetManager.get(f_name);
				this.f_name = f_name;
			},
			fileGetName : function() {
				return this.f_name;
			}
		});

// 背景
tm.define("tm.app.BackImages", {
	init : function(that) {
		this.scene = that;
		this.imgArys = ["BACK", "BACK_G", "BACK_S"];
		//
		this.ary = [tm.app.SpriteBack("BACK_G")];
		this.ary[1] = tm.app.SpriteBack(this._readBackImg());
		this.ary[1].y = SCREEN_HEIGHT * -1;
		this.ary.allMethodCall(function(obj) { obj.origin = tm.geom.Vector2(0, 0); });
		var s_g = tm.sound.SoundManager.get("drive_ground");
		var s_r = tm.sound.SoundManager.get("drive_road");
		this.se_drive_sounds = {
			ground : s_g,
			road : s_r
		}
		
	},
	scroll_move : function(scroll_speed) {
		var that = this;
		this.ary.allMethodCall(function(obj) {
			obj.y += scroll_speed;
			if (obj.y >= SCREEN_HEIGHT) { // 背景再セット
				obj.y = SCREEN_HEIGHT * -1;
				obj.imageSet(that._readBackImg());
			}
		});
		// 毎フレーム入れて要素化
		this.seaScreenY = function(){
			var y = -1 ;
			that.ary.allMethodCall(function(obj) {
				if (obj.fileGetName() == "BACK_S"){
					if(y < obj.y + obj.height)y = obj.y + obj.height;
				}
			});
			if(y < 0)return -99999;
			return y;			
		}();
	},
	seaScreenY : null ,
	_readBackImg : function() {
		var f_index = 0;
		if (this.scene.isStopPointThrow() || this.scene.player.real_y > SCREEN_HEIGHT * -1)
			f_index = 1;
		if (this.scene.isGoalPointThrow())
			f_index = 2;
		return this.imgArys[f_index];
	},
	driveSound : function(){
		var str = null;
		var player = this.scene.player;
		this.ary.allMethodCall(function(obj) {
			if (obj.isHitElement(player)){ str = obj.fileGetName(); }
		});
		//
		if(str != this.backUpStr){
			for(var key in this.se_drive_sounds){
				if (this.se_drive_sounds.hasOwnProperty(key)){
					if(key.isPlay)key.stop();
				}
			}
		}
		this.backUpStr = str;
		if(str == "BACK")return this.se_drive_sounds.road;
		if(str == "BACK_G")return this.se_drive_sounds.ground;
		return null;
	}
});

// 敵ライダー
tm.define("tm.app.Rider", {
			superClass : "tm.display.Sprite",
			init : function(player) {
				this.superInit("RIDER");
				this.x = player.x;
				this.y = player.y;
				this.player = player;
				this.real_y = 0;
				this.speed = 3;
				// 初め速くてあとゆっくり、の為にスピード係数を作るか　あと値の最高値
				this.speed_if = [30 , 50 , 80 ,125]
				this.speed_numbers = [4 , 3 , 2 , 1.7]
			},
			scroll_move : function() {
				this.real_y -= this.speed;
				// プレイヤー絶対座標からの計算
				this.y = (this.real_y - this.player.real_y) + this.player.y;
			},
			speedUp : function() {
				var speed_number = 1.0;
				for(var i = 0 ; i < this.speed_if.length ; i++){
					if(this.speed <= this.speed_if[i])speed_number = this.speed_numbers[i];
				}
				this.speed += speed_number;
			},
			speedDown : function(){
				if(this.speed > 0)this.speed *= 0.97;
			}
		});

tm.define("tm.app.baseCutIn", {
	init : function() {},
	update : function (){} , 
	sw : false ,
	die : function(){}
});
		
//ゴール前カットイン
tm.define("tm.app.GoalCutIn", {
			superClass : "tm.app.baseCutIn",
			init : function(scene) {
				this.superInit();
				this.scene = scene;
				this.backMirror = tm.app.Sprite("BACK_MIRROR");
				this.seaMirror = tm.app.Sprite("MIRROR_SEA");
				this.backMirror.x = this.seaMirror.x = SCREEN_WIDTH / 2;
				this.backMirror.y = this.seaMirror.y = SCREEN_HEIGHT / 2;
				this.seaZoom();
				//距離バーより表示優先順位は下。
				var index = scene.getChildAt(scene.gauge);
				scene.addChildAt(this.seaMirror ,index);
				scene.addChildAt(this.backMirror , index+1);
			},
			sw : true,
			update : function() {
				this.seaZoom();
			},
			seaZoom : function() {
				this.seaMirror.setScale(
						(Math.abs(this.scene.player.real_y) / userData.goal),
						(Math.abs(this.scene.player.real_y) / userData.goal));
			},
			die : function() {
				this.scene.removeChild(this.seaMirror);
				this.scene.removeChild(this.backMirror);
			}
		});

//ゴールぎりぎりタイヤカットイン
tm.define("tm.app.GoalTaiyaCutIn", {
			superClass : "tm.app.baseCutIn",
			init : function(scene) {
				this.superInit();
				this.scene = scene;
				this.road = tm.app.Sprite("CUT_GOAL_ROAD");
				this.taiya = tm.app.Sprite("CUT_GOAL_TAIYA");
				this.x = SCREEN_WIDTH / 2;
				this.road.x = this.taiya.x = SCREEN_WIDTH / 2;
				this.road.y = this.taiya.y = SCREEN_HEIGHT / 2;
				scene.addChild(this.road);
				scene.addChild(this.taiya);
			},	
			update : function(){
				var x_add = 150 - this.scene.seaGetDistanceY(); 
				this.taiya.x = this.x - x_add;
			},
			die : function() {
				this.scene.removeChild(this.road);
				this.scene.removeChild(this.taiya);
			}			
});
// プレイヤー
tm.define("tm.app.Player", {
			superClass : "tm.display.Sprite",
			init : function(scene) {
				this.superInit("CAR");
				this.x = SCREEN_WIDTH / 2;
				this.y = SCREEN_HEIGHT;
				this.real_y = 0;
				this.before_x = null;
				this.total_before_move = 0;
				this.se_drive = null;
				this.scene = scene;
			},
			mousePosSet : function(mouse_postion, braking) { // マウス位置 or
				// タッチ位置に移動
				this.x = mouse_postion.x;
				if (braking) {
					if (!this.before_x)this.before_x = this.x;
					this.throwSpeedDown_();
				}
			},
			inputUpdate : function(app){　//入力 
				if(this.engine == "swiming")return ; // 海に落ちてたら操作不能
				if (userData.speed > 1)this.driveSound(this.scene.backs);
				//
		    	this.mousePosSet(app.pointing , this.scene.isStopPointThrow());
		    	if(this.engine == "brake")return ; //ブレーキ押したらあとはもう止まるばかり。
		    	if(this.scene.isStopPointThrow() && app.pointing.getPointingStart() ){ //停止線超えたら一発ストップ
	    			this.se_breake = tm.sound.SoundManager.get("breake");
	    			this.se_breake.play();
	    			this.engine = "brake";
		    	}
		    	else if(app.pointing.getPointing()){this.engine = "dash";}
		    	else{ this.engine = "";}
			},
			update : function(app) {
				this.scroll_move();
				this.inputUpdate(app);
				if (this.engine == "dash")this.speedUp();
				if (this.engine == "brake")this.speedDown();
			},
			
			driveSound : function(backs){
				var se = backs.driveSound();
				if(se && this.se_drive != se){
					if(this.se_drive)this.se_drive.stop();
					this.se_drive = se;
					this.se_drive.play();					
				}			
			},
			driveSoundStop : function(){
				this.se_drive.stop();
			},
			speedUp : function() {
				userData.speed += 0.5;
			},
			speedDown : function() {
				if (userData.speed > 0)userData.speed *= 0.95;
			},
			scroll_move : function() {
				this.real_y -= userData.speed;
			},			
			throwSpeedDown_ : function() { // ブレーキ中に左右で更に減速
				this.total_before_move += Math.abs(this.before_x - this.x);
				if (this.total_before_move > 300) {
					this.total_before_move = 0;
					userData.speed -= 3;
				}
				this.before_x = this.x;
			}
		});

// ゴールまでの距離表示、その中に自機位置と停止線と敵位置表示
tm.define("MainScene.Goal", {
			superClass : "tm.display.RectangleShape",
			init : function(width, height, param) {
				this.superInit(width, height, param);
				this.player_mark = tm.display.CircleShape(20, 20);
				this.player_mark.origin = tm.geom.Vector2(0.5, 0.0);
				this.rider_mark = tm.display.RectangleShape(20, 20);
				this.rider_mark.origin = tm.geom.Vector2(0.5, 0.0);
				this.stop_line = tm.app.RectangleShape(this.width + 10, 10, {
							strokeStyle : "black"
						});
			},
			setPotions : function(x, y) {
				this.x = this.player_mark.x = this.rider_mark.x = this.stop_line.x = x;
				this.y = y;
				this.stop_line.y = this.underY() - Math.round(userData.stopPoint * (this.height / userData.goal));
			},
			addAllChild : function(that) {
				that.addChild(this);
				that.addChild(this.rider_mark);
				that.addChild(this.player_mark);
				that.addChild(this.stop_line);
			},
			DrawUpdate : function(player, rider) {
				this.player_mark.y = this.underY() + Math.round(player.real_y * (this.height / userData.goal));
				this.rider_mark.y = this.underY() + Math.round(rider.real_y * (this.height / userData.goal));
			},
			underY : function() {
				return this.y + this.height / 2;
			}
		});

//タイトル時のメッセージ後ろの黒幕
tm.define("tm.display.backImglabel", {
	superClass : tm.display.Label,
	init : function(text, size){
		this.superInit(text, size);
		var s_ary = text.split("\n");
		var text_length = 0;
		for(var i = 0; i < s_ary.length;i++){
			var s_l = s_ary[i].length;
			if(text_length < s_l)text_length = s_l;
		}
		//
		var v_param = {fillStyle : "black" , strokeStyle : "black"};
		this.back_img = tm.display.RectangleShape(text_length * this.fontSize , this.fontSize * this.lineHeight * s_ary.length, v_param);
		this.back_img.alpha = 0.3;
	},
	updateBack : function(){
		this.back_img.x = this.x ;
		this.back_img.y = this.y + (this.back_img.height * (this.lineHeight - 1));	 
	},
    addChildTo: function(parent) {
    	this.updateBack();
    	parent.addChild(this.back_img);
        parent.addChild(this);
        return this;
    }
});			

// ランダムカットインの元
tm.define("tm.app.rndCutObj", {
	superClass : "tm.display.Sprite",
	
	init : function(number){
		this.superInit("CUT_RAND_" + number);		
		this.number = number;
		this.count = 0;
	},
	voice_play : function(){ //ボイス再生
		if(Math.random()*100 <= 65){
			var s_ary = ["" , "zoku" , "rady" , "koku" , "zako" , "zizi"];
			//
			var level = 0;
			if(userData.speed > SPEED_LEVEL_VALUE * 0.6)level = 2;
			else level = 1;
			tm.sound.SoundManager.get("v_" + s_ary[this.number] + level).play();
		}
	} ,	
	set_rnd_potion : function(length){
		this.x = (function(){
				var r_n = Math.floor(Math.random()*3);
				if(r_n == 0)return 100;
				if(r_n == 1)return 320;
				if(r_n == 2)return 540;				
			})();
		this.y = 150;
		this.alpha = 0;
		//
		var add_y = 3 + ( (length - 1) * 1);
		var add_alpha = 0.05 + ( (length - 1) * 0.02);
		var wait_time = 1.0 / add_alpha * 60;	
		//動きの設定
		this.timeline.by({"y": add_y * 30 }, wait_time);	
		this.tweener.fadeIn( wait_time / 2).fadeOut( wait_time / 2);
	}
});

//ランダムカットイン配列
tm.define("rndCutInAry", {
	init : function(scene){
		this.ary = [];
		this.count = 0;
		this.scene = scene;
	},
	
	update : function(){
		this.count++;
		if(this.count % 40 == 0){
			var r_n = Math.floor(Math.random()*6);
			if(r_n > 0){
				var obj = tm.app.rndCutObj(r_n);
				obj.set_rnd_potion(this.ary.length);
				obj.voice_play();
				//
				this.sceneAdd(obj);
			}
		}
	},
	
	sceneAdd : function(add_obj) {
		this.ary.push(add_obj);
		this.scene.addChild(add_obj);
	}

});
