//定数系はsetting.jsに


/*
 * メイン処理(ページ読み込み後に実行される)
 */
tm.main(function() {
	// ユーザーデータの生成
    userData = tm.util.DataManager.get("userData");
    // アプリケーション作成
    var app = tm.app.CanvasApp("#world");
    app.resize(SCREEN_WIDTH, SCREEN_HEIGHT); // リサイズ
    app.fitWindow();    // 自動フィット
    
	app.replaceScene(TitleScene());
    // 実行
    app.run();
});

/**
 * TitleScene
 */
tm.define("TitleScene", { // タイトルシーン改造(タイトルに説明文字)
    superClass: tm.app.Scene,
 
    init : function() {
        this.superInit();
        var title_bgm = tm.sound.SoundManager.get("title_bgm");
        title_bgm.play();
        //背景   
        var texture = tm.asset.AssetManager.get("TitleImage" + userData.titleLevel);
        this._backgroundImage = tm.display.Sprite(texture, SCREEN_WIDTH, SCREEN_HEIGHT);
        this._backgroundImage.originX = this._backgroundImage.originY = 0;
        this.addChild(this._backgroundImage);
        
        //タイトル文字     
        var label = tm.display.Label("ツッパれ!　ヤンキーロード" , 58);
        var t_obj = {
        	x : SCREEN_WIDTH / 2 , y : 80 ,
        	width : SCREEN_WIDTH , align : "center" , baseline : "middle" ,
        	_fontFamily : "'ＭＳ Ｐ明朝', 'ＭＳ ゴシック'" , fontWeight : "bold" ,
        	stroke : true , strokeStyle : "black"
        };
	    label.property_set(t_obj);
        this.addChild(label);        
        //更に説明を拡張
        var descption = "海めがけてフルスルットル!　\nどれだけブレーキをがまんできるか!?"
        var label = tm.display.backImglabel(descption , 32);
        var t_obj = {
        	x : SCREEN_WIDTH / 2 , y : SCREEN_HEIGHT / 2 + 100,
        	align : "center" , baseline : "middle"
        }
		label.property_set(t_obj)
        label.addChildTo(this);
           
		// 画面(シーンの描画箇所)をタッチした時の動作
        this.addEventListener("pointingend", function(e) {
        	title_bgm.play().stop();
        	if(ALREADY_READ_ASSET){
        		e.app.replaceScene(MainScene());
        	}else{
            	// シーンの遷移
	            var loadingScene = tm.app.LoadingScene({
	                assets: ASSETS,
	                nextScene: MainScene,
	                width: SCREEN_WIDTH,
	                height: SCREEN_HEIGHT
	            });
	            e.app.replaceScene(loadingScene);
        	}
        });
    }
});

tm.define("MainScene", {
    superClass: "tm.app.Scene",
	
    init: function() {
        // 親の初期化
        this.superInit();
        var that = this;

        this.max_speed = 0;
        this.player = tm.app.Player(this);
        this.rider = tm.app.Rider(this.player);
		//背景
		this.backs = tm.app.BackImages(this);
		//まとめてシーンにセット
        this.backs.ary.allMethodCall(function(obj){ that.addChild(obj); });
       
        this.addChild(this.player);
		this.addChild(this.rider);
        // スピードのラベル
		l_obj = { x : 240, y : 30, align : "end", fontSize : 32 ,
			textUpdate : function(){ this.text = "スピード : " + Math.round(userData.speed); }
		}
		this.speedLabel = tm.display.Label();
		this.speedLabel.property_set(l_obj);
		this.addChild(this.speedLabel);
		
		//ゴールまでのゲージ
		this.gauge = MainScene.Goal(40,300 , {fillStyle : "#EEEE00" , strokeStyle : "#EEEE00" });
		this.gauge.setPotions(600,300);
		this.gauge.addAllChild(this);
		
		this.goalCutIn = tm.app.baseCutIn();
		//
		tm.sound.SoundManager.get("whistle").play();
		
		//ランダムカットイン候補
        this.rnd_cut_in = rndCutInAry(this);
    },

    update: function(app) {
    	if(this.max_speed < userData.speed)this.max_speed = userData.speed;
    	//
    	if(this.slowly.sw)this.slowly.count++;
    	if(this.slowly.sw == false || this.slowly.count % 3 == 0){
	        var that = this;
	    	//スクロール関係
	        this.backs.scroll_move(userData.speed);
	        //敵アルゴリズム
			this.rider.scroll_move();
			if(this.isStopPointThrow()){
				this.rider.speedDown();
			}else{
				this.rider.speedUp();
			}
			//
			if(this.player.engine != "swiming"){
				if(this.seaGetDistanceY() < SCREEN_HEIGHT && userData.speed <= 50){ // 海が画面内に入った 
					if(this.goalCutIn.sw != "taiya"){
						this.goalCutIn.die();
						this.goalCutIn = tm.app.GoalTaiyaCutIn(this);
						this.goalCutIn.sw = "taiya";
						this.slowly = {sw : true , count : 0}
					}
				}
				else if(this.isStopPointThrow()){ // ストップ線こえた
					if(! this.goalCutIn.sw )this.goalCutIn = tm.app.GoalCutIn(this);
				}
			}

			this.player.update(app);
			this.goalCutIn.update();
			if(! this.isStopPointThrow())this.rnd_cut_in.update();
    	}
    	
		//ゴール
		if(this.isStopPointThrow() && userData.speed <= 1){
			if(this.seaGetDistanceY() <= 0){
				userData.rank = "ＡＯＨＯ";
				if(this.max_speed >= SPEED_LEVEL_VALUE )userData.score = "有明の海にドボン";
				else userData.score = "池ポチャ";			
				this.goalMethod(app);
			}else{
				this.goalBonus();
				this.goalMethod(app);
			}
		}
		//離れすぎてゲムオバ
		if(this.rider.y < this.player.y - 3000 ){
			userData.rank = "ＡＯＨＯ";
			userData.score = "ヘタレ";
			this.goalMethod(app);			
		}		
		//行き過ぎて池ポチャ
		if(this.seaGetDistanceY() <= 0){
			userData.speed *= 0.8;
			this.waterDropFunc();
			this.waterDropFunc = function(){};				 				
		}

		//距離バー、ラベル更新
		this.gauge.DrawUpdate(this.player , this.rider);
		this.speedLabel.textUpdate();
    },
    
	isStopPointThrow : function(){ // ストップポイント通過してるか
		return userData.stopPoint <= Math.abs(this.player.real_y) ;
	},
	isGoalPointThrow : function(){ // ゴール通過してるか
		return userData.goal <= Math.abs(this.player.real_y) ;
	},
	goalBonus : function(){ // 距離と、スピードが段差的な階級になっている
		var ary = null;
		if(this.seaGetDistanceY() <= 160){
			ary = ["Ｓ" , "舎弟にして下せえ!" , 3];
		}else if(this.seaGetDistanceY() <= 230 &&　this.max_speed >= SPEED_LEVEL_VALUE){
			ary = ["Ａ+" , "環状の悪魔" , 3];
		}else if(this.seaGetDistanceY() <= 300){
			ary = ["Ａ" , "'キレて'やがるｯ…!" , 2];
		}else if(this.seaGetDistanceY() <= 470 &&　this.max_speed >= SPEED_LEVEL_VALUE){
			ary = ["Ｂ+" , "ぶっちぎり最速伝説" , 2];
		}else if(this.seaGetDistanceY() <= 640){
			ary = ["Ｂ" , "テメーの名前、覚えておくぜ" , 1];
		}else if(this.seaGetDistanceY() <= 830 &&　this.max_speed >= SPEED_LEVEL_VALUE){
			ary = ["Ｃ+" , "県下最速" , 1];
		}else if(this.seaGetDistanceY() <= 1050){
			ary = ["Ｃ" , "やるじゃねえか" , 1];
		}else{
			if(this.max_speed >= SPEED_LEVEL_VALUE ){
				ary = ["ＡＯＨＯ" , "口先だけのピエロ" , 0];
			}else{
				ary = ["ＡＯＨＯ" , "腰抜け金髪野郎" , 0];
			}
		}
		userData.rank = ary[0];
		userData.score = ary[1];
		var backUpLevel = ary[2];			
		if(backUpLevel > userData.titleLevel)userData.titleLevel = backUpLevel;
	},
	seaGetDistanceY : function(){ //海までの距離
		return (this.player.y - this.player.height / 2) - this.backs.seaScreenY;
	},
	goalMethod : function(app){ // ゴール(終了)した際の処理
		if(this.player.se_drive)this.player.se_drive.stop();
		app.replaceScene(tm.app.EndScene());
	},
	slowly : {sw : false , count : null} , // スローモードかどうか
	waterDropFunc : function(){
		this.player.engine = "swiming";
		if(this.se_breake)this.se_breake.stop();
		this.player.driveSoundStop();
		tm.sound.SoundManager.get("water_fall").play();
		//
		var v_param = {fillStyle : "blue" , strokeStyle : "blue"};
		this.blue_over = tm.display.RectangleShape(SCREEN_WIDTH , SCREEN_HEIGHT , v_param); 
		this.blue_over.origin = tm.geom.Vector2(0, 0);
		this.blue_over.alpha = 0.5;
		this.addChild(this.blue_over);
		this.goalCutIn.die();
	}
});

/**
 * EndScene　（ResultSceneのスコア：を変えただけ)　文言って後から代入して再びレンダリングってできないっけ。
 */
tm.define("tm.app.EndScene", {
	superClass: tm.app.Scene,
	 
    init : function() {
        this.superInit();
              
		var param = {
	        score: userData.score,
	        rank : userData.rank,
	        msg:      "",
	        hashtags: "tmlibjs",
	        width:    SCREEN_WIDTH,
	        height:   SCREEN_HEIGHT,
	        related: "tmlib.js tmlife javascript"
		};    	
        var text = "ランク{rank}: {score}, {msg}".format(param);
        var twitterURL = this.tweetURL = tm.social.Twitter.createURL({
            type    : "tweet",
            text    : text,
            hashtags: param.hashtags,
            url     : param.url // or window.document.location.href
        });

        if (param.backgroundImage) {
            var texture = tm.asset.AssetManager.get(param.backgroundImage);
            this._backgroundImage = tm.display.Sprite(texture, param.width, param.height);
            this._backgroundImage.originX = this._backgroundImage.originY = 0;
            this.addChild(this._backgroundImage);
        }
        
        var scoreLabel = tm.display.Label("ランク{rank}: {score}".format(param));
        scoreLabel.x = param.width/2;
        scoreLabel.y = param.height/2-70;
        scoreLabel.width = param.width;
        scoreLabel.align     = "center";
        scoreLabel.baseline  = "middle";
        scoreLabel.fontSize = 32;
        this.addChild(scoreLabel);
        
        var msgLabel = tm.display.Label(param.msg);
        msgLabel.x = param.width/2;
        msgLabel.y = param.height/2-20;
        msgLabel.width = param.width;
        msgLabel.align     = "center";
        msgLabel.baseline  = "middle";
        msgLabel.fontSize = 16;
        this.addChild(msgLabel);
        
        // ツイートボタン
        var tweetButton = this.tweetButton = tm.ui.GlossyButton(120, 50, "blue", "Tweet").addChildTo(this);
        tweetButton.setPosition(param.width/2 - 65, param.height/2 + 50);
        tweetButton.onclick = function() {
            window.open(twitterURL);
        };
        
        // 戻るボタン
        var backButton = tm.ui.GlossyButton(120, 50, "black", "Back").addChildTo(this);
        backButton.setPosition(param.width/2 + 65, param.height/2 + 50);
        backButton.onpointingstart = function() {
            var e = tm.event.Event("nextscene");
            this.dispatchEvent(e);
        }.bind(this);
    },
    
    // Backボタンを押したらTitleSceneに戻る
    onnextscene: function (e) {
    	ALREADY_READ_ASSET = true;
    	var t = userData.titleLevel; // 持ち越し
    	userDataReset();
    	userData = tm.util.DataManager.get("userData");
    	userData.titleLevel = t;
        e.target.app.replaceScene(TitleScene());
    }       
});